#!/usr/local/bin/perl

# -tab <num>     ...Change tab code into corresponding space.
# -width <width> ...Insert space in the end of line.
# -line <digit>  ...Insert line number.
# * Change code \r\n to \n.
# * Multi-byte code (KANJI) is supported.

$tab   = 0;
$width = 0;
$line  = 0;

while ($_ = shift(@ARGV)) {
	if    ($_ eq "-tab"  ) { $tab   = shift(@ARGV); }
	elsif ($_ eq "-width") { $width = shift(@ARGV); }
	elsif ($_ eq "-line" ) { $line  = shift(@ARGV); }
	elsif ($_ eq "-o"    ) { $file  = shift(@ARGV); }
	else {
		push(@files, $_);
	}
};

@ARGV = @files;

if ($file ne "") {
	open(FILE, "> $file");
	$handle = FILE;
} else {
	$handle = STDOUT;
}

while (<>) {
	$linenum++;
	($_, $lineend) = /([^\r\n]*)([\r\n]*)/;
	if ($tab > 0) {
		while (/\t/) {
			$column = index($_, "\t");
			$s = " " x ($tab - ($column % $tab));
			substr($_, $column, 1) = $s;
		}
	}
	if ($lineend ne "") {
		$lineend = "\n";
	}
	$s = " " x ($width - length($_));
	$_ = $_ . $s . $lineend;
	if ($line > 0) {
		$_ = sprintf("%0*d:", $line, $linenum) . $_;
	}
	print $handle "$_";
}
